export interface GetTextIndicesSearchResult {
    start: number;
    end: number;
}
export interface GetTextIndicesOptions {
    caseSensitive?: boolean;
    multiple?: boolean;
}
/**
 * Finds the indices of the 'searchText' in the 'fullStr'
 * @param {string} fullStr The string to search on
 * @param {string} searchText The string to find indices in the 'fullStr'
 * @param {GetTextIndicesOptions} options The options
 */
export declare function getTextIndices(fullStr: string, searchText: string, options?: GetTextIndicesOptions): GetTextIndicesSearchResult[];
