"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTextIndices = void 0;
var defaultOptions = {
    caseSensitive: true,
    multiple: false,
};
/**
 * Finds the indices of the 'searchText' in the 'fullStr'
 * @param {string} fullStr The string to search on
 * @param {string} searchText The string to find indices in the 'fullStr'
 * @param {GetTextIndicesOptions} options The options
 */
function getTextIndices(fullStr, searchText, options) {
    if (options === void 0) { options = defaultOptions; }
    var _a = __assign(__assign({}, defaultOptions), options), caseSensitive = _a.caseSensitive, multiple = _a.multiple;
    if (typeof fullStr !== 'string')
        throw new Error("'fullStr' must be string");
    else if (typeof searchText !== 'string')
        throw new Error("'searchText' must be a string");
    else if (typeof multiple !== 'boolean')
        throw new Error("'multiple' must be a boolean");
    var regex = new RegExp(searchText, "g" + (caseSensitive ? '' : 'i'));
    var searchResults = __spread(fullStr.matchAll(regex));
    var results = [];
    if (!searchResults)
        return results;
    searchResults.forEach(function (result) {
        var startIndex = result.index;
        if (typeof startIndex !== 'number' || !searchText)
            return;
        results.push({
            start: startIndex,
            end: startIndex + (searchText.length - 1),
        });
    });
    return results;
}
exports.getTextIndices = getTextIndices;
